package Bugzilla::API::Controller::REST;
use strict;
use warnings;

use base 'Catalyst::Controller::REST';

sub begin : ActionClass('Deserialize') { 
  my ($self, $c) = @_;
  $c->stats->enable(1);
  $c->stats->profile(begin => "Request");
}

sub end : ActionClass('Serialize') { 
  # Output timing reports
  my ($self, $c) = @_;
  $c->stats->profile(end => "Request");
  $c->log->info("\n" . scalar($c->stats->report()));
}

__PACKAGE__->config('default' => 'application/json');
__PACKAGE__->config->{'map'} = { 
  'application/json' => 'JSON',
  'application/javascript' => 'JSONP',
  'text/html' => 'YAML::HTML'
};

1;